﻿DECLARE
v_portletid NUMBER;
v_actionid NUMBER; 
v_userid NUMBER; 
v_rightid NUMBER;
v_menuitemid NUMBER;
v_username  VARCHAR2 (50);
/*Get the user id. Will select all users that are Active Users and Active Resources
This select statement may be modified to include only a specific resource or a group of resources*/
CURSOR c_cursor
IS
select s.user_id from prj_resources r, srm_resources s, cmn_sec_users u 
where 
r.prid = s.id
and s.user_id = u.id
and s.is_active=1
and u.user_status_id = 200
order by s.user_id;

BEGIN
DBMS_OUTPUT.ENABLE(1000000000);
IF NOT c_cursor%ISOPEN THEN
OPEN c_cursor;
END IF;
LOOP
FETCH c_cursor INTO v_userid;
EXIT WHEN c_cursor%NOTFOUND 
OR c_cursor%NOTFOUND IS NULL;

select user_name into v_username from cmn_sec_users 
where id =  v_userid;

DBMS_OUTPUT.PUT_LINE ('Checking user ' || v_username);

/*Get the portlet id. If the portlet does not exist, create the portlet and update the captions. */
begin
select id into v_portletid from cmn_portlets 
where portlet_code like '%union.favLeftNav' 
and principal_id =v_userid;
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Nabídka Oblíbené', 'Nabídka Oblíbené', 1, null, null, null, null, null,'cs');                        
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Menuen Favoritter', 'Menuen Favoritter', 1, null, null, null, null, null,'da');                      
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Favoritenmenü', 'Favoritenmenü', 1, null, null, null, null, null,'de');                              
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Favorites Menu', 'Favorites Menu', 1, null, null, null, null, null,'en');                            
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Menú de favoritos', 'Menú de favoritos', 1, null, null, null, null, null,'es');                      
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Suosikit-valikko', 'Suosikit-valikko', 1, null, null, null, null, null,'fi');                        
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Menu Favoris', 'Menu Favoris', 1, null, null, null, null, null,'fr');                                
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Kedvencek menü', 'Kedvencek menü', 1, null, null, null, null, null,'hu');                            
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Menu Preferiti', 'Menu Preferiti', 1, null, null, null, null, null,'it');                            
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'お気に入りメニュー', 'お気に入りメニュー', 1, null, null, null, null, null,'ja');                                      
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, '즐겨찾기 메뉴', '즐겨찾기 메뉴', 1, null, null, null, null, null,'ko');                                          
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Menu Favorieten', 'Menu Favorieten', 1, null, null, null, null, null,'nl');                          
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Favoritter-meny', 'Favoritter-meny', 1, null, null, null, null, null,'no');                          
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Menu ulubionych', 'Menu ulubionych', 1, null, null, null, null, null,'pl');                          
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Menu Favoritos', 'Menu Favoritos', 1, null, null, null, null, null,'pt');                            
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Меню избранного', 'Меню избранного', 1, null, null, null, null, null,'ru');                          
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Favoriter-meny', 'Favoriter-meny', 1, null, null, null, null, null,'sv');                            
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, 'Sık Kullanılanlar Menüsü', 'Sık Kullanılanlar Menüsü', 1, null, null, null, null, null,'tr');        
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, '收藏夹菜单', '收藏夹菜单', 1, null, null, null, null, null,'zh');                                              
 cmn_captions_nls_upd_sp('CMN_PORTLETS',v_portletid, '我的最愛功能表', '我的最愛功能表', 1, null, null, null, null, null,'zh_TW');  
exception
when no_data_found then 
select cmn_portlets_s1.nextval into v_portletid from dual;
DBMS_OUTPUT.PUT_LINE ('Inserted Portlet ID ' || v_portletid || ' for user ' || v_username);
INSERT INTO cmn_portlets (
        id, portlet_code, source, category_id, status_code,
        is_wide, mime_type_code, portlet_view_type_code,
        view_source, component_code, portlet_type_code,
        is_system, is_active, instance_type,
        principal_id, principal_type,
        created_date, created_by, last_updated_date, last_updated_by )
        VALUES (v_portletid,v_userid||'.union.favLeftNav','clarity.ca.com',50209,'NORMAL',1,'vxsl','toc','menu.xsl','union','FAVORITE',1,1,'FAVORITE',v_userid,'USER',sysdate,1,sysdate,1);
WHEN OTHERS THEN
DBMS_OUTPUT.PUT_LINE ('ErrCode=' || SQLCODE || ' ErrMsg=');
END;		

/* Make sure the Favorites - Edit instance right is created, if not, insert it */ 
begin
select csaop.id into v_rightid  from cmn_sec_assgnd_obj_perm csaop, cmn_sec_groups g
    where g.group_code = 'UserFavoriteEditor'
    and csaop.principal_type = 'USER'
    and csaop.right_id = g.id
    and csaop.principal_id = v_userid;
exception
when no_data_found then 
cmn_sec_assign_inst_right_sp ('USER', v_username, 'UserFavoriteEditor', v_portletid);
DBMS_OUTPUT.PUT_LINE ('Inserted Instance Right for user ' || v_username);
when others THEN
DBMS_OUTPUT.PUT_LINE ('ErrCode=' || SQLCODE || ' ErrMsg=');
END;	

/* Make sure the action is created, if not, insert it and update the captions */ 
begin
select id into v_actionid from CMN_ACTIONS where action_code = v_userid||'.My Links'; 
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Moje odkazy', 'Moje odkazy', 1, null, null, null, null, null,'cs');                                  
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Mine links', 'Mine links', 1, null, null, null, null, null,'da');                                    
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Eigene Verknüpfungen', 'Eigene Verknüpfungen', 1, null, null, null, null, null,'de');                
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'My Links', 'My Links', 1, null, null, null, null, null,'en');                                        
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Mis vínculos', 'Mis vínculos', 1, null, null, null, null, null,'es');                                
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Omat linkit', 'Omat linkit', 1, null, null, null, null, null,'fi');                                  
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Mes liens', 'Mes liens', 1, null, null, null, null, null,'fr');                                      
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Hivatkozásaim', 'Hivatkozásaim', 1, null, null, null, null, null,'hu');                              
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Collegamenti personali', 'Collegamenti personali', 1, null, null, null, null, null,'it');            
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'マイ リンク', 'マイ リンク', 1, null, null, null, null, null,'ja');                                            
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, '내 링크', '내 링크', 1, null, null, null, null, null,'ko');                                                
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Mijn koppelingen', 'Mijn koppelingen', 1, null, null, null, null, null,'nl');                        
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Mine koblinger', 'Mine koblinger', 1, null, null, null, null, null,'no');                            
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Moje łącza', 'Moje łącza', 1, null, null, null, null, null,'pl');                                    
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Meus links', 'Meus links', 1, null, null, null, null, null,'pt');                                    
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Мои ссылки', 'Мои ссылки', 1, null, null, null, null, null,'ru');                                    
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Mina länkar', 'Mina länkar', 1, null, null, null, null, null,'sv');                                  
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, 'Bağlantılarım', 'Bağlantılarım', 1, null, null, null, null, null,'tr');                              
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, '我的链接', '我的链接', 1, null, null, null, null, null,'zh');                                                
 cmn_captions_nls_upd_sp('CMN_ACTIONS',v_actionid, '我的連結', '我的連結', 1, null, null, null, null, null,'zh_TW');    
exception
when no_data_found then 
select CMN_ACTIONS_S1.nextval into v_actionid from dual;

INSERT INTO CMN_ACTIONS
        ( ID, ACTION_CODE, ALIAS_CODE ,PAGE_ID,TARGET,
        IS_SYSTEM, IS_ACTIVE, IS_SSL_ENABLED,
        PRINCIPAL_TYPE, PRINCIPAL_ID,
        CREATED_DATE, CREATED_BY, LAST_UPDATED_DATE, LAST_UPDATED_BY)
  VALUES
        ( v_actionid, v_userid||'.My Links', null, 0, null,
        0, 0, 0, 'USER', v_userid,
        sysdate, 1, sysdate, 1);
 DBMS_OUTPUT.PUT_LINE ('Inserted Action ' || v_actionid || ' for user ' || v_username);
end;
/* Make sure the menu items are inserted, if not, insert them */ 
begin 
select id into v_menuitemid from cmn_menu_items 
where principal_id =v_userid
and container_id = v_portletid
and action_id = v_actionid;
exception
when no_data_found then 
select cmn_menu_items_s1.nextval into v_menuitemid from dual;
INSERT INTO cmn_menu_items
        (
        id, principal_type, principal_id,
        item_type_code, container_type_code, container_id,
        action_id, parent_menu_id,
        menu_item_level, position, image_name, is_favorite,
        is_default, is_required,
        created_date, created_by,
        last_updated_date, last_updated_by
        )
        VALUES
        ( v_menuitemid, 'USER', v_userid,
        'MENU', 'MENU', v_portletid,
        v_actionid, null,
        0, 0, null, 1,
        0, 1,
        sysdate, 1,
        sysdate, 1);
DBMS_OUTPUT.PUT_LINE ('Inserted Menu ' || v_menuitemid || ' for user ' || v_username );
end;
END LOOP;
END;